# model of Hill and Weir
#E(r²)= (10+C)       (1+  (3+C)(12+12C+C²))
#      --------	 X       ----------------
#    (2+C)(11+C)	    NE (2+C)(11+C)
#C=(4 *  population size (N) * Distance)    
#NE = sample size
#
#samplesize <- sample size (input)
#R2 <- r² values between pairs of markers (input)
#Dist <- distances between pairs of markers in cM (or bp), same order and lenght as R2 (input)
#
#estimated value of population size (if distance in cM) (output)
HillWeir.est<-function(R2,Dist,samplesize)
{
#Modèle de Hill&Weir
mod_X <-nls(R2~(((10+4*N*Dist)/((2+4*N*Dist)*(11+4*N*Dist)))*(1+((3+4*N*Dist)*(12+12*4*N*Dist+(4*N*Dist)*(4*N*Dist)))/(samplesize*(2+(4*N*Dist))*(11+(4*N*Dist))))),start=list(N=0.0001), trace=TRUE)
O<-(summary(mod_X))
N.est=O$parameters[1]
N.est
}

#to compute the curve Y axis
HillWeir.cal<-function(Dist,samplesize,N){
Y<-( (10+4*N*Dist)/ ( (2+4*N*Dist)*(11+4*N*Dist) ) )*( 1+( (3+4*N*Dist)*(12+12*4*N*Dist+(4*N*Dist)*(4*N*Dist)) )/( samplesize*(2+(4*N*Dist))*(11+(4*N*Dist)) ) )
Y}

#usage
#N.est<-HillWeir.est(R2,Dist,samplesize)
#HillWeir.Y<-HillWeir.cal(Dist,samplesize,N.est)
#plot(Dist,HillWeir.Y)
