#install.packages()
library(LDcorSV)
library(LDheatmap)
source("HW.R")
source("transform.R")
#lecture fichiers
geno.17.SA<-read.csv("geno.17.SA.csv",row.names=1)
geno.17.TE<-read.csv("geno.17.TE.csv",row.names=1)
K.SA<-read.csv("K.SA.csv",row.names=1)
K.TE<-read.csv("K.TE.csv",row.names=1)
#pb du nom des colonnes des kinships, R ne veut pas à la lecture trouver des rownames égaux aux colnames
colnames(K.TE)<-rownames(K.TE)
colnames(K.SA)<-rownames(K.SA)
#nbre d'individus, nbre de marqueurs, apparentement
nrow(geno.17.TE)
nrow(geno.17.SA)
ncol(geno.17.TE)
ncol(geno.17.SA)
mean( as.matrix( K.TE[lower.tri(K.TE)] ) )
mean( as.matrix( K.SA[lower.tri(K.SA)] ) )
#données manquantes, r2
sum(is.na(geno.17.SA[,1]))
sum(is.na(geno.17.SA[,3]))
cor( geno.17.SA[,1], geno.17.SA[,3])^2
#LDcorSV
LD.Measures(geno.17.SA[,c(1,3)],supinfo=T)
#LDheatmap
geno.17.SA.allele<-transform(geno.17.SA)
map<-position(colnames(geno.17.SA))
LDheatmap(geno.17.SA.allele,genetic.distances=map)
#LDcorSV
LD.17.SA<-LD.Measures(geno.17.SA,V=K.SA)
#LDheatmap
X11()
LD.17.SA.r2v.mat<-rempli.matrice(LD.17.SA$r2v,ncol(geno.17.SA))
LDheatmap(LD.17.SA.r2v.mat,genetic.distances=map)
#position des loci
pos.loc1<-position(LD.17.SA$loc1)
pos.loc2<-position(LD.17.SA$loc2)
dis.loc1loc2<-abs(pos.loc1-pos.loc2)
X11()
plot(dis.loc1loc2,LD.17.SA$r2v)
X11()
plot(dis.loc1loc2,LD.17.SA$r2)
#ajustement de Hill et Weir, étendue du DL
taillepop.SA.r2<-HillWeir.est(LD.17.SA$r2,dis.loc1loc2,nrow(geno.17.SA))
Y.HW.SA.r2<-HillWeir.cal(dis.loc1loc2,nrow(geno.17.SA),taillepop.SA.r2)
plot(dis.loc1loc2,Y.HW.SA.r2)
max(dis.loc1loc2[which(Y.HW.SA.r2>=0.1)])
taillepop.SA.r2v<-HillWeir.est(LD.17.SA$r2v,dis.loc1loc2,nrow(geno.17.SA))
Y.HW.SA.r2v<-HillWeir.cal(dis.loc1loc2,nrow(geno.17.SA),taillepop.SA.r2v)
X11()
plot(dis.loc1loc2,Y.HW.SA.r2v)
max(dis.loc1loc2[which(Y.HW.SA.r2v>=0.1)])
#
#mélange des populations
#création des données
don<-melange.pop(geno.17.TE,geno.17.SA,K.TE,K.SA)
LD.17<-LD.Measures(don$geno,V=don$kinship,S=don$struct)
LDheatmap(rempli.matrice(LD.17$r2,ncol(don$geno)),genetic.distances=map )
X11()
LDheatmap(rempli.matrice(LD.17$r2s,ncol(don$geno)),genetic.distances=map )







